#!/home/ekkie/venvs/sitelen-gen/bin/python3
import sys
import os
from urllib.parse import parse_qs
from PIL import Image, ImageDraw, ImageFont

font_file = "/home/ekkie/files/sitelenselikiwenasuki.ttf"
font_size = 72
stroke_width = int(font_size * 0.03)


def main(text):
    font = ImageFont.truetype(font_file, size=font_size)
    image = Image.new('RGB', (1, 1), color='white')
    draw = ImageDraw.Draw(image)
    _, _, w, h = draw.textbbox((0, 0), text, font=font)
    image = Image.new('RGBA', (w+font_size, h+font_size), (0, 0, 0, 0))
    draw = ImageDraw.Draw(image)
    draw.text(
        (int(font_size/2), int(font_size/2)), text, font=font, fill='white',
        stroke_fill='black', stroke_width=stroke_width)
    image.crop(image.getbbox()).save(sys.stdout.buffer, 'PNG')


if __name__ == "__main__":
    text = os.environ.get("QUERY_STRING", "")
    text = parse_qs(text).get("text", None)
    text = text[0].replace("\r", "") if text else text
    if not text:
        print("Status: 400 Bad Request")
        print("Content-Type: text/plain")
        print()
        print("Please provide a text query parameter")
    else:
        print("Content-Type: image/png\n", flush=True)
        main(text)
